<?php
/**
* @version      $Id: myrssreader.php v 1.0
* @package      Search - My RSS Reader
* @copyright    Copyright (C) 2010 FalsinSoft. All rights reserved.
* @license      GNU/GPL
* @website      http://www.falsinsoft.co.nr
* @email        falsinsoft@gmail.com
* 
*/

defined( '_JEXEC' ) or die( 'Restricted access' );

$mainframe->registerEvent('onSearch', 'plgSearchRSSFeeds');
$mainframe->registerEvent('onSearchAreas', 'plgSearchRSSFeedsAreas');

function &plgSearchRSSFeedsAreas() 
{
	static $areas = array(
		'myrssreader' => 'RSS Feeds'
	);
	return $areas;
}

function plgSearchRSSFeeds($text, $phrase = '', $ordering = '', $areas = null)
{
	$db	=& JFactory::getDBO();

	$searchText = $text;
	
	if(is_array( $areas )) 
	{
		if(!array_intersect($areas, array_keys(plgSearchRSSFeedsAreas()))) 
		{
			return array();
		}
	}

 	$plugin =& JPluginHelper::getPlugin('search', 'myrssreader');
 	$pluginParams = new JParameter($plugin->params);

	$limit = $pluginParams->def('search_limit', 50);

	$text = trim($text);
	
	if($text == '') return array();
	
	$wheres	= array();
	
	switch($phrase)
	{
		case 'exact':
		
			$text		= $db->Quote('%'.$db->getEscaped($text, true).'%', false);
			$wheres2 	= array();
			$wheres2[] 	= 'a.item_title LIKE '.$text;
			$wheres2[] 	= 'a.item_content LIKE '.$text;
			$where 		= '('.implode(') OR (', $wheres2).')';
			break;

		case 'all':
		case 'any':
		default:
		
			$words 	= explode(' ', $text);
			$wheres = array();
			foreach($words as $word)
			{
				$word		= $db->Quote('%'.$db->getEscaped($word, true).'%', false);
				$wheres2 	= array();
				$wheres2[] 	= 'a.item_title LIKE '.$word;
				$wheres2[] 	= 'a.item_content LIKE '.$word;
				$wheres[] 	= implode(' OR ', $wheres2);
			}
			$where 	= '('.implode(($phrase == 'all' ? ') AND (' : ') OR ('), $wheres).')';
			break;
	}

	switch($ordering)
	{
		case 'oldest':
			$order = 'a.item_date ASC';
			break;

		case 'alpha':
			$order = 'a.item_title ASC';
			break;

		case 'popular':
		case 'category':
		case 'newest':
		default:
			$order = 'a.item_date DESC';
	}

	$query = 'SELECT a.item_title AS title, a.item_content AS text, a.item_date AS created, a.item_link AS href,'
	. ' "1" AS browsernav, "RSS Feed" AS section'
	. ' FROM #__myrssreader_cache AS a'
	. ' WHERE ('.$where.')'
	. ' GROUP BY a.id'
	. ' ORDER BY '.$order
	;
	
	$db->setQuery($query, 0, $limit);
	
	$rows = $db->loadObjectList();

	$return = array();
	
	foreach($rows AS $key => $feed) 
	{
		if(searchHelper::checkNoHTML($feed, $searchText, array('url', 'text', 'title'))) 
		{
			$return[] = $feed;
		}
	}

	return $return;
}
